config/routes.rb
Rails.application.routes.draw do

  
  resources :projects do
    resources :tickets do
      member do
        put :change
      end
      resources :timelogs
      resources :checkboxes do
        member do 
          patch :complete
        end 
      end
      resources :comments
    end
  end
  resources :lists do 
    resources :tasks do
      member do 
        put :change
        put :complete
      end
    end
  end 
  
  get 'pages/home'
  get 'about' => 'pages#about'
  get 'peoples' => 'pages#peoples'

  root 'projects#index'
  devise_for :users, :controllers => { registrations: 'registrations' }

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/ticket.rb
class Ticket < ApplicationRecord
  belongs_to :project
  has_many :timelogs, dependent: :destroy
  has_many :comments, dependent: :destroy
  has_many :checkboxes, dependent: :destroy
  
  accepts_nested_attributes_for :timelogs
  accepts_nested_attributes_for :comments
  accepts_nested_attributes_for :checkboxes
  def previous
  	Ticket.where(["id < ? and project_id =?", id, project_id]).last
  end

  def next
  	Ticket.where(["id > ? and project_id = ?", id, project_id]).first
  end

  def placement
    Ticket.where(["project_id = ?", project_id]).order('id ASC').index(self)
  end

end

app/controllers/tickets_controller.rb
class TicketsController < ApplicationController
  before_action :set_ticket, only: [:show, :change, :edit, :update, :destroy]
  before_action :set_project
  # GET /tickets
  # GET /tickets.json
  def index
    @tickets = @project.tickets.all
  end

  # GET /tickets/1
  # GET /tickets/1.json
  def show
    @users = User.all
    @timelogs = @ticket.timelogs.all
    @comments = @ticket.comments.all
    @checkboxes = @ticket.checkboxes.all
    @comment = Comment.new
  end

  # GET /tickets/new
  def new
    @ticket = Ticket.new
    @ticket.timelogs.build
    @ticket.comments.build
    @ticket.checkboxes.build
  end

  # GET /tickets/1/edit
  def edit
  end

  # POST /tickets
  # POST /tickets.json
  def create
    @ticket = @project.tickets.create(ticket_params)

    respond_to do |format|
      if @ticket.save
        format.html { redirect_to @project, notice: 'Ticket was successfully created.' }
        format.json { render :show, status: :created, location: @ticket }
      else
        format.html { render :new }
        format.json { render json: @ticket.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /tickets/1
  # PATCH/PUT /tickets/1.json
  def update
    respond_to do |format|
      if @ticket.update(ticket_params)
        format.html { redirect_to @project, notice: 'Ticket was successfully updated.' }
        format.json { render :show, status: :ok, location: @ticket }
      else
        format.html { render :edit }
        format.json { render json: @ticket.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /tickets/1
  # DELETE /tickets/1.json
  def destroy
    @ticket.destroy
    respond_to do |format|
      format.html { redirect_to @project, notice: 'Ticket was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  def change
    @ticket.update_attributes(state: params[:state])
    respond_to do |format|
      format.html { redirect_to @project, notice: 'Task state was successfully changed.' }
    end
  end
  def new_checkbox
  respond_to do |format|
    format.html
    format.js
  end
end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_ticket
      @ticket = Ticket.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def ticket_params
      params.require(:ticket).permit(:subject, :description, :priority, :project_id, :state, :closed_at, :user_id, :estimated_hours)
    end

    def set_project
      @project = Project.find(params[:project_id])
    end
end

app/helpers/ticket_helper.rb
module TicketHelper
end

app/helpers/tickets_helper.rb
module TicketsHelper
end

app/views/tickets/_form.html.erb
<!-- app/views/layouts/modal.html.erb -->

  <div class="modal-dialog">
    <div class="modal-content">
<%= simple_form_for [@project, @ticket] do |f| %>
  <%= f.error_notification %>
  <div class="form-inputs"> 
    <%= f.input :subject %>
    <%= f.input :description %>
    <%= f.input :priority, :collection => ['urgent', 'high', 'normal', 'low'],:label => "Priority" , :selected => 'normal', :include_blank => false %>
        <%= f.input :user_id, :collection => User.all.map {|u| [ [u.name, u.last_name].join(" "), u.id]}, :label => "Assignee" ,:include_blank => false %>
        <%= f.input :state, :collection => ['New', 'In Progres', 'Closed'],:label => "State" , :selected => 'New', :include_blank => false %>
    <%= f.input :closed_at %>
    <%= f.input :estimated_hours %>
  </div>
  <div class="form-actions">
    <%= f.button :submit %>
  </div>
<% end %>    </div><!-- /.modal-content -->
  </div><!-- /.modal-dialog -->

app/views/tickets/edit.html.erb
<h1>Editing Ticket</h1>

<%= render 'form', ticket: @ticket %>

<%= link_to 'Show', @project %> |
<%= link_to 'Back', project_ticket_path %>

app/views/tickets/index.html.erb
<p id="notice"><%= notice %></p>
<div class="container">
  <nav class="breadcrumb">
    <%= link_to "Home", root_path, class: "breadcrumb-item"%>
    <%= link_to "Projects", projects_path, class: "breadcrumb-item" %>
    <span class="breadcrumb-item active"> <%= @project.name %></span>
  </nav>
  <br>
  <div class="row">
    <div class="col btn-group">
      <button class="btn btn-secondary"> <%= link_to 'Overview', @project %> </button>
      <button class="btn btn-secondary active"><%= link_to 'Issues', project_tickets_path(@project) %></button>
      <button class="btn btn-secondary"><%= link_to 'New Issue', new_project_ticket_path(@project) %></button>
      <button class="btn btn-secondary">My Issues</button>
    </div>
  </div>
  <div class="row">
    <div class="col">
      <div class="card">
        <table  class="table table-bordered table-striped">
          <thead>
            <tr>
              <th>ID</th>
              <th>Subject</th>
              <th>State</th>
              <th>Priority</th>
              <th>Last Action</th>
              <th>Comments</th>
              <th>Time</th>
              <th  class="sorter-false" colspan="5" ></th>
            </tr>
          </head>
          <tbody>
            <% @tickets.each_with_index do |ticket, index| %>
            <tr>
              <td>
                <%= ticket.id %>
                <% if ticket.checkboxes.try(:any?) %>
                &nbsp;<a href=""><i class='fa fa-hand-o-down' data-toggle="collapse" data-target="#checkboxes<%=index.to_s%>"></i></a>
                <% end %>
              </td>
              <td><%=ticket.subject %></td>
              <td><%=ticket.state %></td>
              <td><%= ticket.priority %></td>
              <td>
                <% if ticket.comments.try(:any?) %>
                <%= time_ago_in_words(ticket.comments.maximum('updated_at')) %>
                <% else %>
                <%= time_ago_in_words(ticket.updated_at) %>
                <% end %>
              </td>
              <td><%= ticket.comments.count %></td>
              <td>
                <%= ticket.timelogs.sum(:spend_time)%> / 
                <%= ticket.estimated_hours %>
              </td>
              <% if ticket.state == "new" %>
              <td><%= link_to "<i class='fa fa-arrow-right'></i>".html_safe, change_project_ticket_path(@project, ticket, state: "in progres" ), method: :put %></td> 
              <%else %>
              <td><%= link_to "<i class='fa fa-arrow-down'></i>".html_safe, change_project_ticket_path(@project, ticket, state: "closed" ), method: :put %></td> 
              <% end %>
              <td><%= link_to "<i class='fa fa-clock-o'></i>".html_safe, new_project_ticket_timelog_path(@project, ticket) %></td>
              <td><%= link_to "<i class='fa fa-eye'></i>".html_safe, project_ticket_path(@project,ticket) %></td>
              <% if current_user.id == ticket.user_id %>
              <td><%= link_to "<i class='fa fa-pencil'></i>".html_safe, edit_project_ticket_path(@project, ticket) %></td>
              <td><%= link_to "<i class='fa fa-times'></i>".html_safe, project_ticket_path(@project,ticket), method: :delete, data: { confirm: 'Are you sure?' } %></td>
              <% end %>
            </tr>
            <tr id="checkboxes<%= index.to_s%>" class="collapse out">
              <td>
              </td>
              <td>
                <div>
                  <ol>
                    <% ticket.checkboxes.each do |c| %>
                    <% if c.completed_at? %>
                    <div class="row">
                      <div class="col-sm-3">
                        <i class='fa fa-check-square-o'></i>
                        <%= link_to "<i class='fa fa-times'></i>".html_safe, project_ticket_checkbox_path(@project, ticket, c), method: :delete, data: { confirm: 'Are you sure?' } %>
                      </div>              
                      <div class="col-sm-9">
                        <s><%= c.content %></s>
                      </div>
                    </div>

                    <% else %>
                    <div class="row">
                      <div class="col-sm-3">
                        <%= link_to "<i class='fa fa-square-o'></i>".html_safe, complete_project_ticket_checkbox_path(@project,ticket, c), method: :patch %>
                      </div>
                      <div class="col-sm-9">
                        <%= c.content %>
                      </div>
                    </div>
                    <% end %>
                    <% end %>
                  </ol>
                </div>
              </td>
            </tr>
            <% end %>
          </tbody>
        </table>
      </div>
    </div>
  </div>
</div>

app/views/tickets/new.html.erb
<div class="container">
<div class="container">
  <nav class="breadcrumb">
    <%= link_to "Home", root_path, class: "breadcrumb-item"%>
    <%= link_to "Projects", projects_path, class: "breadcrumb-item" %>
    <span class="breadcrumb-item active"> <%= @project.name %></span>
  </nav>
  <br>
  <div class="row">
    <div class="col btn-group">
      <button class="btn btn-secondary"> <%= link_to 'Overview', @project %> </button>
      <button class="btn btn-secondary"><%= link_to 'Issues', project_tickets_path(@project) %></button>
      <button class="btn btn-secondary active"><%= link_to 'New Issue', new_project_ticket_path(@project) %></button>
      <button class="btn btn-secondary">My Issues</button>
    </div>
  </div>
<br>
<h3>New Ticket</h3>

<%= render 'form', ticket: @ticket %>

<%= link_to 'Back', @project %>

</div>

app/views/tickets/show.html.erb
<p id="notice"><%= notice %></p>
<div class="container">
    <nav class="breadcrumb">
    <%= link_to "Home", root_path, class: "breadcrumb-item"%>
    <%= link_to @project.name, project_path(@project), class: "breadcrumb-item" %>
    <%= link_to "Tickets", project_tickets_path, class: "breadcrumb-item" %>
    <span class="breadcrumb-item active"> <%= @ticket.subject %></span>
  </nav>
  <div class="row">
  <div class="col-sm-10">
    <div class="card">
      <div class="card-header">
          <b> <%= @ticket.subject %></b>
          <div class="pull-right">
          <% if current_user.id == @ticket.user_id %>
            <%= link_to "<i class='fa fa-pencil'></i>".html_safe, edit_project_ticket_path(@project, @ticket) %> &nbsp;
            <% end %>
            <%= link_to   "<i class='fa fa-clock-o'></i>".html_safe, new_project_ticket_timelog_path(@project,@ticket) %> &nbsp;
            <i class='fa fa-star'></i>&nbsp;
            <%= link_to "<i class='fa fa-angle-double-left'></i>".html_safe, project_ticket_path(@project, @ticket.previous) if @ticket.previous %> &nbsp;|&nbsp;
            <%= @ticket.placement+1 %> of <%= @project.tickets.count %>&nbsp;|&nbsp;
            <%= link_to "<i class='fa fa-angle-double-right'></i>".html_safe, project_ticket_path(@project, @ticket.next) if @ticket.next %>
          </div>
      </div>
      <div class="card-block">
        <p class="text-muted small"> Created in <%= time_ago_in_words(@ticket.created_at)%> ago. <% if @ticket.comments.try(:any?) %> Updated <%= time_ago_in_words(@ticket.comments.maximum('updated_at')) %> ago.<% end %> </p>
        <div class="row">
          <div class="col-6">
            <dl class="row">
              <dt class="col-sm-4">Status</dt>
                <dd class="col-sm-8"> <%= @ticket.state %> </dd>
              <dt class="col-sm-4">Priority</dt>
                <dd class="col-sm-8"><%= @ticket.priority %></dd>
              <dt class="col-sm-4">Assignee</dt>
                <dd class="col-sm-8 text-red"><%= @users.find(@ticket.user_id).name %>&nbsp;<%= @users.find(@ticket.user_id).last_name %></dd>  
            </dl>
          </div>
          <div class="col-6">
            <dl class="row">
              <dt class="col-sm-4">Start date</dt>
                <dd class="col-sm-8"><%= @ticket.created_at.to_formatted_s(:long)  %></dd>
              <dt class="col-sm-4">Due date</dt>
                <dd class="col-sm-8"><%=  distance_of_time_in_words(Time.now, @ticket.closed_at, options = {})  if @ticket.closed_at? %></dd>
              <dt class="col-sm-4"> Spent time </dt>
                <dd class="col-sm-8"> <%= @ticket.timelogs.sum('spend_time') if @ticket.timelogs.try(:any?) %> </dd>
            </dl>
          </div>
        </div>
        <dl class="row">
          <dt class="col-sm-2">Description</dt>
            <dd class="col-sm-10"> <%= @ticket.description %> </dd>
        </dl>

      </div>
    </div>
  </div>
  </div>
<div class="row">
  <div class="col-sm-10">
  <div class="card">
    <div class="card-header">
      <b> Checklist <%= link_to "<i class='fa fa-plus'></i>".html_safe, new_project_ticket_checkbox_path(@project, @ticket) %> </b>     
    </div>
    <% if @ticket.checkboxes.try(:any?) %>
    <div class="card-block">

          <% @ticket.checkboxes.each do |c| %>
            <% if c.completed_at? %>
            <div class="row">
              <div class="col-sm-1">
                <i class='fa fa-check-square-o'></i>
                <%= link_to "<i class='fa fa-times'></i>".html_safe, project_ticket_checkbox_path(@project, @ticket, c), method: :delete, data: { confirm: 'Are you sure?' } %>
              </div>
              <div class="col-sm-4">
                <s><%= c.content %></s>
              </div>
              </div>
              <% else %>
            <div class="row">
              <div class="col-sm-1">
                <%= link_to "<i class='fa fa-square-o'></i>".html_safe, complete_project_ticket_checkbox_path(@project,@ticket, c), method: :patch %>
              </div>
              <div class="col-sm-4">
                <%= c.content %>
              </div>
              </div>
              <% end %>
          <% end %>     
    </div>
    <% end %>
  
  </div>
  </div>
  </div>
  <br>
  <div class="row">
    <div class="col-sm-10">
    <div class="card-header" role="tab" id="headingOne">
      <b class="mb-0">
      <% if @ticket.timelogs.try(:any?) %>
        <a data-toggle="collapse" data-parent="#accordion" href="#timelogs" aria-expanded="false" aria-controls="collapseOne"> Time Logs <span class="text-muted small pull-right"> Last log <%= time_ago_in_words(@ticket.timelogs.maximum('created_at')) %> ago.</span> <i class="fa fa-angle-down"></i>
        </a>
        <% else %>
          Time Logs
        <% end %>
      </b>
    </div>

    <div id="timelogs" class="collapse" role="tabpanel" aria-labelledby="headingOne">
      <div class="card-block">
      <table class="table table-bordered table-striped">
        <thead>
          <tr>
            <th>ID</th>
            <th>Time</th>
            <th>Activity</th>
            <th>Note</th>
          </tr>
        </thead>
        <tbody>
          <% @ticket.timelogs.each do |timelog| %>
            <tr>
              <td> <%= timelog.id %></td>
              <td> <%= timelog.spend_time%></td>
              <td> <%= timelog.activity%></td>
              <td> <%= timelog.comment%></td>
            </tr>
          <% end %>
        </tbody>
        <tfoot>
          <tr>
            <th> SUM </i></th>
            <th> <%= @ticket.timelogs.sum('spend_time') if @ticket.timelogs.try(:any?) %> </th>
          </tr>
        </tfoot>
      </table>
      </div>
    </div>
    </div>
  </div>
  <br>
  <div class="row">
    <div class="col-sm-10">
      <div class="card">
        <div class="card-header"><b>Comments</b></div>
        <div class="card-block">
        <% if @ticket.comments.try(:any?) %>
        <% @ticket.comments.each do |comment| %>
          <div class="row">
          <div class="col-sm-8">
            <div class="card">
              <div class="card-header small"> Created by xy <%= time_ago_in_words(comment.created_at) %> ago.
              <div class="pull-right"> 
              <%= link_to "<i class='fa fa-pencil'></i>".html_safe, edit_project_ticket_comment_path(@project,@ticket,comment) %> &nbsp;
              <%= link_to "<i class='fa fa-times'></i>".html_safe , project_ticket_comment_path(@project,@ticket,comment), method: :delete, data: { confirm: 'Are you sure?' } %>
                
              </div> 
              </div>
              <div class="card-block"> 
                <%= comment.note %>
              </div>
            </div>
          </div>
          </div>
          <br>
          <%end %>
          <% else %>
          <p class="text-muted small"> No Comments to show </p>
          <%end %>
        </div>
      </div>
    </div>
  </div>
  <br>
  <div class="row">
    <div class="col-sm-10">
      <div class="card">
        <div class="card-header"><b>New Comment</b></div>
        <div class="card-block">
        <div class="col-md-10">
          <%= render 'comments/form', comment: @comment %>
          </div>
        </div>
      </div>
    </div>
  </div>
  </div>
</div>